{*******************************************}
{                                           }
{ Pomocny .TPU soubor.                      }
{ Copyright (c) 1997 Pavel Holecek          }
{                                           }
{*******************************************}

unit mytpu;

interface
uses crt,dos;
const myresult:integer=0;
var  my_me:array [1..5,1..20] of string[20];
     nmenu:array [1..5] of string[18];
     pocmenu :integer;
     mymenter:integer;
     mlong:boolean;
procedure savescr(ks:integer);		{Ulozi textovou obrazovku}
procedure restorescr(cs:integer);	{Obnovi textovou obrazovku}
procedure bigwrite(copsat:string);	{Velky font}
procedure changelog(co,vypzap:integer);	{Zapne/vypne capslock, numlock}
procedure cursor(state:boolean);	{Zapne/vypne kurzor}
procedure mnew(num1,num2:integer;tex:string);{Definice novehe polozky menu}
procedure mdel(n1:integer);		{Smazani menu}
procedure mview(nu1:integer);		{Spusteni menu}
function  msgerr(mm_c:integer):string;	{Id chyby -> text}
procedure showmcursor;			{Zobrazi kurzor mysi}
procedure HideMCursor;			{Skryje kurzor mysi}
function  GetMouseType:Byte;		{Mys}
procedure MouseStatus(var PosX,PosY:word; var buttons:byte); {x,y,tlacitka}
procedure textcon(mc_text:string;var mc_text1:string;mc_co:integer);
procedure updown(mu_text:string;var mu_text1:string;mu_co:integer);
					{Upcase vcetne diakritiky}
function  DOW(Day, Month, Year: Integer) : Integer;	{Den v tydnu}
function  ordlet(mo_znak:char):integer;	{Poradi znaku}
procedure color(mc_1,mc_2:integer);	{textcolor+textbackground}
procedure coder(mc_kod:string;mc_k:integer;var mc_cod:string); {kodovani}
procedure ssound(ms_vz,ms_dz:integer);	{sound+delay+nosound}
procedure play(mp_cp:string);		{Hraje noty}
procedure frame(mf_x,mf_y,mf_x1,mf_y1,mf_typ:integer);  {Textovi ramecek}
procedure circut(c1,c2:integer);			{Nastav. kruznoce}
procedure scircle(cx,cy,cp:integer;czn:char);		{Textova kruznoce} 
procedure sline(lx1,ly1,lx2,ly2:integer;lch:char);	{Textova cara}
procedure swapclr;			{textcolor <-> textbackground}

implementation
const cv1:integer=1;
      cv2:integer=60;
type scre=array[1..80,1..25] of word;
var screen:scre absolute $B800:$0000;
    sscr:array[1..10] of scre;

procedure savescr(ks:integer);
begin
 myresult:=0;
 if (ks<1) then myresult:=1;
 if (ks>10) then myresult:=2;
 if (myresult<>0) then exit;
 sscr[ks]:=screen;
end;

procedure updown(mu_text:string;var mu_text1:string;mu_co:integer);
const mc_data:array[1..2,1..41] of char=
(('a','b','c','d','e','f','g','h','i','j','k','l','m','n','o','p','q','r','s','t','u','v','w','x','y','z','','','','',
  '','','','','','','','','','',''),
 ('A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z','','','','',
  '','','','','','','','','','',''));
var mc_i,mc_ii:integer;
begin
 myresult:=0;
 begin
  for mc_i:=0 to length(mu_text) do
  begin
   mu_text1[mc_i]:=mu_text[mc_i];
   if (mu_co=1) then for mc_ii:=1 to 41 do if (mu_text[mc_i])=mc_data[1,mc_ii] then mu_text1[mc_i]:=mc_data[2,mc_ii];
   if (mu_co=0) then for mc_ii:=1 to 41 do if (mu_text[mc_i])=mc_data[2,mc_ii] then mu_text1[mc_i]:=mc_data[1,mc_ii];
  end;
 end;
end;

procedure restorescr(cs:integer);
begin
 myresult:=0;
 if (cs<1) then myresult:=1;
 if (cs>10) then myresult:=2;
 if (myresult<>0) then exit;
 screen:=sscr[cs];
end;

procedure bigwrite(copsat:string);
const big:array[1..30] of string[30]=
('   a   a a   a   a',
 '  a   a a   a a',
 '  a   a    a   aa',
 ' a   a   a   aa',
 ' a    a a    a a',
 ' a    a a    a    a',
 '  a   a  a   aa',
 '   a   a   aa   a',
 '    a    a    a    a    a',
 '    a    a    a   a  a',
 '   a  a   a  a   a',
 '    a    a    a    a a',
 '   aa  a   a   a',
 '   a a  a   a   a',
 '  a   a   a   a  a',
 '   a  a  a   a    a',
 '  a   a   a a a',
 '   a  a  a  a  a',
 '  a  a   a  a   a',
 'a    a    a    a    a',
 '   a   a   a   aa',
 '   a   a   a a    a',
 '   a   a   a  a   a',
 '   a   a  a a   a',
 '   a   a  a    a    a',
 'a   a   a    aa',
 '     a     a     a   a   a',
 '    a    a    a     a    a',
 '     a     a     a     a     a',
 '     a     aaa     a');
var ii,i,xx,x,px,ppy,p,pis:integer;
    q:string;
begin
 px:=0;ppy:=0;pis:=0;pis:=0;p:=0;i:=0;ii:=0;x:=0;xx:=0;
 px:=wherex;ppy:=wherey;
 for ii:=1 to length(copsat) do
 begin
  updown(copsat[ii],q,1);
  xx:=ord(q[1]);
  x:=xx-64;if x=-18 then x:=27;if x=-31 then x:=28;
  if x=-32 then x:=29;if x=-19 then x:=30;
  if (x<31) and (x>0) then
  begin
   p:=p+1;pis:=0;
   gotoxy(px+(p*10),ppy);
   for i:=1 to 30 do
   begin
    if (big[x,i]<>'a') then write(big[x,i]) else
    begin
     pis:=pis+1;
     writeln;
     gotoxy(px+(p*10),ppy+pis);
    end;
   end;
  end else write(chr(x));
 end;
end;

const scr=$10;
      num=$20;
      cap=$40;
      ins=$80;
procedure nastavpriz(klavesa:byte);
var regs:registers;
    stav:byte absolute $0040:$0017;
begin
 stav:=stav or klavesa;
 regs.Ah:=$01;
 intr($16, regs);
end;

procedure zruspriz(klavesa:byte);
var regs:registers;
    stav:byte absolute $0040:$0017;
begin
 stav:=stav and (not klavesa);
 regs.Ah:=$01;
 intr($16, regs);
end;


procedure changelog(co,vypzap:integer);
begin
 if (vypzap=0) then
 begin
  if co=1 then zruspriz(num);
  if co=2 then zruspriz(cap);
  if co=3 then zruspriz(scr);
 end;
 if (vypzap=1) then
 begin
  if co=1 then nastavpriz(num);
  if co=2 then nastavpriz(cap);
  if co=3 then nastavpriz(scr);
 end;
end;

function  GetMouseType:Byte;
var R:Registers;
begin
  myresult:=0;
  with R do begin
    ax:=0;
    Intr(51,R);
    If ax=0 then GetMouseType:=0
            else GetMouseType:=bx
   end
end;


procedure showmcursor;
var r:registers;
begin
 myresult:=0;
 with r do
 begin
  ax:=1;
  intr(51,r)
 end
end;

procedure HideMCursor;
var R:Registers;
begin
  myresult:=0;
  with R do begin
    ax:=2;
    Intr(51,R)
  end
end;

procedure MouseStatus(var PosX,PosY:word; var buttons:byte);
var R:Registers;
begin
  myresult:=0;
  with R do begin
    ax:=3;
    Intr(51,R);
    PosX:=cx;
    PosY:=dx;
   buttons:=bx;
  end;
  PosX:=(PosX div 8)+1;
  PosY:=(PosY div 8)+1;
end;
procedure cursor(state:boolean);
var reg:registers;
const sstart:byte=12;
      send:byte=14;
begin
 with reg do
        case state of
              true: begin AH:=1;CH:=SStart;CL:=SEnd end;
              false:begin AH:=1;CH:=32;    CL:=0    end;
        end;
 intr($10,reg);
end;

procedure mdel(n1:integer);
var i,ii:integer;
begin
  for ii:=1 to 20 do my_me[1,ii]:='';
end;

procedure mnew(num1,num2:integer;tex:string);
begin
 if (num2>pocmenu) then pocmenu:=num2;
 if (num2=0) then nmenu[num1]:=tex;
 if (num2>0) then my_me[num1,num2]:=tex;
end;

procedure mymx(nu1,zx,zy,y:integer);
var i,maxp:integer;
begin
 maxp:=1;
 for i:=1 to 10 do if (length(my_me[nu1,i])<>0) then inc(maxp);
 gotoxy(10,20);
 textcolor(0);textbackground(7);
 gotoxy(zx,zy+1);writeln   ('Ŀ');
{ gotoxy(zx+1,zy);write('');}
 textbackground(2);write(nmenu[nu1]);textbackground(7);
{ write('');}gotoxy(zx+1,zy+1);write('');
 gotoxy(zx+2+length(nmenu[nu1]),zy+1);write('');
 for i:=1 to maxp do
 begin
  gotoxy(zx,zy+i+1);writeln('                     ');
  gotoxy(zx+2,zy+i+1);
  writeln(my_me[nu1,i]);
 end;
 gotoxy(zx,zy+maxp+1);writeln('');
 textcolor(0);textbackground(2);
 gotoxy(zx+1,y+zy+1);write(#32+my_me[nu1,y]);
 for i:=1 to (20-length(my_me[nu1,y])) do write(' ');
 gotoxy(zx+1,y+zy+1);
end;
procedure mview(nu1:integer);
var ch:char;axa:boolean;
    ac1,ac2,i:integer;
    zx,zy,y,maxp:integer;
    mmx,mmy:word;mstat:byte;
begin
maxp:=1;axa:=false;
for i:=1 to 10 do if (length(my_me[nu1,i])<>0) then inc(maxp);
ac1:=textattr mod 16;
ac2:=textattr div 16;
zx:=wherex;zy:=wherey;
y:=1;
 repeat
  if y=maxp then y:=1;
  if y=0 then y:=maxp-1;
  if ch<>#1 then mymx(nu1,zx,zy,y);ch:=#1;
  delay(50);if keypressed then ch:=readkey;
  mousestatus(mmx,mmy,mstat);mmy:=mmy-1;
  if (mstat=1) and (mmx>zx) and (mmy>zy) then
  if (mmx<zx+22) and (mmy<maxp+zy) then
  begin
   y:=mmy-zy;
   ch:=#13
  end;
  if ch=#0 then
  begin
   ch:=readkey;
   if (ch=#80) then y:=y+1;
   if (ch=#72) then y:=y-1;
   if mlong=true then
   if (ch=#77) or (ch=#75) then
   begin
    if (ch=#77) then begin ch:=#75;mymenter:=-1;end;
    if (ch=#75) then mymenter:=-2;
    axa:=true;
   end;
  end;
 until (ch=#27) or (ch=#13) or (axa=true);
 textcolor(ac1);textbackground(ac2);
 if ch=#27 then mymenter:=0;
 if ch=#13 then mymenter:=y;
end;

function msgerr(mm_c:integer):string;
begin
 if mm_c=0 then msgerr:='Bez chyby';
 if mm_c=1 then msgerr:='Cislo je prilis male';
 if mm_c=2 then msgerr:='Cislo je prilis velke';
 if mm_c=3 then msgerr:='Spatny obsah parametru';
 myresult:=0;
end;

procedure textcon(mc_text:string;var mc_text1:string;mc_co:integer);
const mc_data:array[1..2,1..30] of byte=
((160,135,130,136,131,161,164,162,169,168,159,163,150,152,145,143,128,133,144,137,139,165,149,158,155,134,151,166,157,146),
 (160,159,130,216,212,161,229,162,253,231,156,163,133,236,167,181,172,210,144,183,214,213,224,252,230,155,233,222,237,166));
 {                                           a to same jenze velke}
var mc_i,mc_ii:integer;
begin
 myresult:=0;
 begin
  for mc_i:=0 to length(mc_text) do
  begin
   mc_text1[mc_i]:=mc_text[mc_i];
   if (mc_co=1) then for mc_ii:=1 to 30 do if (ord(mc_text[mc_i])=mc_data[1,mc_ii]) then mc_text1[mc_i]:=chr(mc_data[2,mc_ii]);
   if (mc_co=0) then for mc_ii:=1 to 30 do if (ord(mc_text[mc_i])=mc_data[2,mc_ii]) then mc_text1[mc_i]:=chr(mc_data[1,mc_ii]);
  end;
 end;
end;

function DOW(Day, Month, Year: Integer) : Integer;
var
  century, yr, dw: Integer;
begin
  myresult:=0;
  if (day<1) or (month<1) or (year<1980) then myresult:=1;
  if (day>31) or (month>12) or (year>2099) then myresult:=2;
  if Month < 3 then
  begin
    Inc(Month, 10);
    Dec(Year);
  end
  else
     Dec(Month, 2);
  century := Year div 100;
  yr := year mod 100;
  dw := (((26 * month - 2) div 10) + day + yr + (yr div 4) +
    (century div 4) - (2 * century)) mod 7;
  if dw < 0 then DOW := dw + 7
  else DOW := dw;
end;

function ordlet(mo_znak:char):integer;
const mo_data:array[1..41] of char=
 ('A','','B','C','','D','','E','','','F','G','H','I','','J',
  'K','L','M','N','','O','','P','Q','R','','S','','T','','U',
  '','','V','W','X','Y','','Z','');
var mo_i:integer;
begin
 myresult:=0;
 mo_znak:=upcase(mo_znak);
 for mo_i:=1 to 41 do if (mo_data[mo_i]=mo_znak) then ordlet:=mo_i;
end;

procedure color(mc_1,mc_2:integer);
begin
 myresult:=0;
 if (mc_1>15) or (mc_2>8) then myresult:=1;
 if (mc_1<0) or (mc_2<0) then myresult:=2;
 textcolor(mc_1);
 textbackground(mc_2);
end;

procedure ssound(ms_vz,ms_dz:integer);
begin
  myresult:=0;
  if (ms_vz>20000) or (ms_dz>50000) then myresult:=1;
  if (ms_vz<30) or (ms_dz<0) then myresult:=2;
  sound(ms_vz);
  delay(ms_dz);
  nosound;
end;

procedure coder(mc_kod:string;mc_k:integer;var mc_cod:string);
var
 mc_i,mc_a:integer;
 mc_c:string;
begin
 myresult:=0;
 for mc_i:=1 to length(mc_kod) do
 begin
    mc_a:=ord(mc_kod[mc_i])+mc_k;
    if mc_a>255 then mc_a:=mc_a-255;
    if mc_a<0 then mc_a:=255+mc_a;
    mc_c[mc_i]:=chr(mc_a);
 end;
mc_cod:=mc_c;
delete(mc_cod,length(mc_kod)+1,length(mc_cod));
end;

procedure play(mp_cp:string);
var mp_i,mp_p,mp_d:integer;
begin
myresult:=0;
mp_d:=250;
for mp_i:=1 to length(mp_cp) do
 begin
  if (mp_cp[mp_i]='p') then mp_p:=0;
  if (mp_cp[mp_i]='1') then mp_d:=4000;
  if (mp_cp[mp_i]='2') then mp_d:=2000;
  if (mp_cp[mp_i]='4') then mp_d:=1000;
  if (mp_cp[mp_i]='8') then mp_d:=500;
  if (mp_cp[mp_i]='0') then mp_d:=62;
  if (mp_cp[mp_i-1]='#') then
   begin
    if (mp_cp[mp_i]='c') then mp_p:=277;
    if (mp_cp[mp_i]='d') then mp_p:=311;
    if (mp_cp[mp_i]='f') then mp_p:=370;
    if (mp_cp[mp_i]='g') then mp_p:=416;
    if (mp_cp[mp_i]='a') then mp_p:=466;
   end;
  if  (mp_cp[mp_i-1]<>'#') then
   begin
    if (mp_cp[mp_i]='c') then mp_p:=262;
    if (mp_cp[mp_i]='d') then mp_p:=294;
    if (mp_cp[mp_i]='e') then mp_p:=330;
    if (mp_cp[mp_i]='f') then mp_p:=349;
    if (mp_cp[mp_i]='g') then mp_p:=392;
    if (mp_cp[mp_i]='a') then mp_p:=440;
    if (mp_cp[mp_i]='h') then mp_p:=494;
   end;
  if (mp_cp[mp_i]>='a') and (mp_cp[mp_i]<='h') or (mp_cp[mp_i]='p') then
  begin
   sound(mp_p);delay(mp_d);nosound;delay(20);
  end;
 end;
end;

procedure frame(mf_x,mf_y,mf_x1,mf_y1,mf_typ:integer);
var mf_px,mf_py,mf_i,mf_ii,mf_iii:integer;
    mf_v1,mf_v2,mf_v3,mf_v4:char;
begin
  myresult:=0;
 if (mf_typ=5) then
 begin
  mf_v1:='';mf_v2:=' ';mf_v3:='';
 end;
 if (mf_typ=4) then
 begin
  mf_v1:='';mf_v2:=' ';mf_v3:='';
 end;
 if (mf_typ=3) then
 begin
  mf_v1:='';mf_v2:='0';mf_v3:='';mf_v4:='';
 end;
 if (mf_typ=2) then
 begin
  mf_v1:='';mf_v2:=' ';mf_v3:='';mf_v4:='';
 end;
 if (mf_typ=1) then
 begin
  mf_v1:='';mf_v2:=' ';mf_v3:='';
 end;
 gotoxy(mf_x,mf_y);
 for mf_iii:=1 to mf_x1+1 do write(mf_v3);
 for mf_ii:=1 to mf_y1-2 do
 begin
  write(mf_v1);
   gotoxy(mf_x,wherey);writeln(mf_v1);
   gotoxy(mf_x+mf_x1+1,wherey);
  end;
 gotoxy(mf_x,wherey);
 for mf_iii:=1 to mf_x1+2 do write(mf_v3);
 if (mf_typ=2) then
 begin
  gotoxy(mf_x,mf_y);writeln('');gotoxy(mf_x+mf_x1+1,mf_y);writeln('');
  gotoxy(mf_x,mf_y+mf_y1-2);writeln('');gotoxy(mf_x+mf_x1+1,mf_y+mf_y1-2);writeln('');
 end;
 if (mf_typ=4) then
 begin
  gotoxy(mf_x,mf_y);writeln('');gotoxy(mf_x+mf_x1+1,mf_y);writeln('');
  gotoxy(mf_x,mf_y+mf_y1-2);writeln('');gotoxy(mf_x+mf_x1+1,mf_y+mf_y1-2);writeln('');
 end;
 if (mf_typ=5) then
  begin
   gotoxy(mf_x,mf_y);writeln('');gotoxy(mf_x+mf_x1+1,mf_y);writeln('');
   gotoxy(mf_x,mf_y+mf_y1-2);writeln('');gotoxy(mf_x+mf_x1+1,mf_y+mf_y1-2);writeln('');
  end;
end;

procedure circut(c1,c2:integer);
begin
 if (c1<=60) and (c1>=1) then cv1:=c1;
 if (c2<=60) and (c2>=1) then cv2:=c2;
end;

procedure scircle(cx,cy,cp:integer;czn:char);
var x,y:real;
    i,hod:integer;
begin
   if (cv1<cv2) then for i:=cv1 to cv2 do
   begin
       x := cx + ((cp*2) * SIN(i * pi / 30));
       y := cy - (cp * COS(i * pi / 30));
       gotoxy(round(x),round(y));write(czn);
   end
   else
   for i:=cv1 downto cv2 do
   begin
       x := cx + ((cp*2) * SIN(i * pi / 30));
       y := cy - (cp * COS(i * pi / 30));
       gotoxy(round(x),round(y));write(czn);
   end
end;

procedure sline(lx1,ly1,lx2,ly2:integer;lch:char);
var x,y:real;
   i:integer;
begin
   for i:=1 to ly2 do
     begin
       x := lx1 + ((i*2) * SIN(lx2 * pi / 30));
       y := ly1 - (i * COS(lx2 * pi / 30));
       gotoxy(round(x),round(y));write(lch);
     end;
end;

procedure swapclr;
begin
 myresult:=0;
 color(textattr div 16,textattr mod 16);
end;

end.
